/*
   Utility to unroll shiva layer one encryption
   Copyright (c) 2003, Chris Eagle
   
   This program is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by the Free
   Software Foundation; either version 2 of the License, or (at your option) 
   any later version.
   
   This program is distributed in the hope that it will be useful, but WITHOUT
   ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
   FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
   more details.
   
   You should have received a copy of the GNU General Public License along with 
   this program; if not, write to the Free Software Foundation, Inc., 59 Temple 
   Place, Suite 330, Boston, MA 02111-1307 USA
*/

/*
 * Decode a shiva data block that uses xor encoding
 *
 * Invoke the script and answer the questions.  You will need to do some 
 * initial poking around in IDA to determine the answers to the questions.
 */

#include <idc.idc>

static main() {
   auto start, ecx, nBytes, ebx;
   auto edx, edi, msg;
   
//long    xtol            (string str);           // ascii hex -> number
   edi = here;
   edi = AskAddr(edi, "Enter start address for decode");
   start = edi;
   Message("You entered %x, %d\n", edi, edi);
   edx = AskLong(0, "Number of bytes to decode");
   nBytes = edx;
   Message("You entered %x, %d\n", edx, edx);
   ebx = 0x194A187B;
   msg = form("Initial XOR mask (0x%X)", ebx);
   ebx = AskLong(ebx, msg);
   Message("You entered %x, %d\n", ebx, ebx);

   //ecx = Dword(edi);
   //Message("first word = 0x%X", ecx);
  
   for (; edx >= 4; edx = edx - 4) {
      ecx = Dword(edi);
      ecx = ecx ^ ebx;
      ebx = ebx + ecx;
      MakeUnkn(edi, 1);
      PatchDword(edi, ecx);   // change a dword (4 bytes)
      edi = edi + 4;
   }
   for (; edx > 0; edx = edx - 1) {
      ecx = Byte(edi);
      ecx = ecx ^ ebx;
      ebx = ebx + ecx;
      MakeUnkn(edi, 1);
      PatchByte(edi, ecx);
      edi = edi + 1;
   }
   AnalyseArea(start, start + nBytes);
   
}